//
// C++ Interface: findfiles
//
// Description:
//
//
// Author: minsu kim <minsu.kim@gmail.com>, (C) 2008
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef FINDFILES_H
#define FINDFILES_H

#include <QDialog>
#include <QtGui>

#include "ui_findfilesdlg.h"

/**
	@author minsu kim <minsu.kim@gmail.com>
*/

class QTableWidgetItem;
class KalzipApp;
class QShowEvent;
class QDir;

class FindFilesDlg : public QDialog, public Ui::FindFilesDlg
{
Q_OBJECT
public:
  FindFilesDlg(KalzipApp *app = 0, QWidget *parent = 0);
  ~FindFilesDlg();

private:
  KalzipApp *m_app;

private:
  void initLayout();
  void initConnect();
  void showFiles(const QDir &directory, const QStringList &files);
  QStringList findFiles(const QDir &directory, const QStringList &files, const QString &text);

private slots:
  void browse();
  void find();

  void on_PB_Search_clicked();
  void on_PB_Cancel_clicked();
  void on_TW_FindResult_itemDoubleClicked ( QTableWidgetItem * item );
  void on_TW_FindResult_cellDoubleClicked ( int row, int column );

protected:
  void showEvent(QShowEvent * event );

signals:
  void sigExtract(const QString &);

};

#endif
