//
// C++ Implementation: kalzipapp
//
// Description:
//
//
// Author: minsu kim <minsu.kim@gmail.com>, (C) 2008
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "global.h"

#include <QApplication>

#include "kalzipapp.h"

#include "mainwindow.h"
#include "wizarddlg.h"
#include "informationdlg.h"
#include "aboutdlg.h"
#include "findfilesdlg.h"
#include "splashscreen.h"

KalzipApp::KalzipApp(QObject *parent)
 : QObject(parent)
 , m_findfiles(0)
 , m_info(0)
 , m_wizard(0)
 , m_mainwin(0)
 , m_about(0)
{
}

KalzipApp::~KalzipApp()
{
  delete m_findfiles;
  delete m_info;
  delete m_wizard;
  delete m_mainwin;
  delete m_about;
}

void KalzipApp::init(int argc, char ** argv)
{
  m_qApp = new QApplication(argc, argv);

  SplashScreen *splash = new SplashScreen(QPixmap(":images/kalzip_logo.png"), 5); // 5sec later
  splash->exec();
  
#if 0
  if (!QFile::exists(kalzip_tmp_path)) {
    QDir dir("/tmp/");
    if ( !dir.mkdir("kalzip/") ) { // error?
      qTrace << "mkdir /tmp/kalzip error!";
    }
  }

  // read save configure
  QSettings *setting = new QSettings("KDE", "Kalzip");
  // recently files
  m_recentFiles.clear();
  m_recentFiles << settings->value("recentlyfile1");
  // settings->value("recentlyfile2");
  // settings->value("recentlyfile2");
  // settings->value("recentlyfile2");
  m_recentDirs << settings->value("recentlyDir1");
#endif

  m_mainwin   = new MainWindow(this);
  m_wizard    = new WizardDlg(this);
  m_info      = new InformationDlg(this);
  m_findfiles = new FindFilesDlg(this);
  m_about     = new AboutDlg(this);

  m_mainwin->show();
}

void KalzipApp::exec(void)
{
  m_qApp->exec();
}

void KalzipApp::quit(void)
{
  // QSettings config file save?
  m_qApp->quit();
}
