//
// C++ Interface: kalzipapp
//
// Description:
//
//
// Author: minsu kim <minsu.kim@gmail.com>, (C) 2008
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef KALZIPAPP_H
#define KALZIPAPP_H

#include <QObject>

/**
	@author minsu kim <minsu.kim@gmail.com>
*/

class QApplication;

class MainWindow;
class InformationDlg;
class WizardDlg;
class FindFilesDlg;
class AboutDlg;

class KalzipApp : public QObject
{
Q_OBJECT

public:
  KalzipApp(QObject *parent = 0);
  ~KalzipApp();

public:
  void init(int argc, char** argv);
  void exec(void);
  void quit(void);

  // get methods
  MainWindow      *getMainWindow() const          { return m_mainwin;   }
  InformationDlg  *getInformationDlg() const      { return m_info;      }
  WizardDlg       *getWizardDlg() const           { return m_wizard;    }
  FindFilesDlg    *getFindFilesDlg() const        { return m_findfiles; }
  AboutDlg        *getAboutDlg() const            { return m_about;     }

private:
  QApplication *m_qApp; // not use now?

  MainWindow            *m_mainwin;
  InformationDlg        *m_info;
  WizardDlg             *m_wizard;
  FindFilesDlg          *m_findfiles;
  AboutDlg              *m_about;

  //QStringList m_recentFiles, m_recentDirs;

};

#endif
