//
// C++ Interface: mainwindow
//
// Description:
//
//
// Author: minsu kim <minsu.kim@gmail.com>, (C) 2008
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QSystemTrayIcon>

#include "ui_mainwindow.h"
#include "UnAlz.h"
#include "UnAlzUtils.h"

/**
	@author minsu kim <minsu.kim@gmail.com>
*/

class QComboBox;
class QDirModel;
class QModelIndex;
class QTimer;
class QFileInfo;
class KalzipApp;

class MainWindow : public QMainWindow, public Ui::MainWindow
{
Q_OBJECT

public:
  MainWindow(KalzipApp *app = 0, QWidget *parent = 0);
  ~MainWindow();

private slots:
  // File Menu
  void on_AC_Open_archive_triggered( bool checked = false );
  void on_AC_Exit_triggered( bool checked = false );
  // Commands Menu  
  void on_AC_Extract_to_triggered( bool checked = false );
  // Tools Menu
  void on_AC_Find_Files_triggered( bool checked = false );
  // Help menu
  void on_AC_About_Qt_triggered( bool checked = false );
  void on_AC_About_triggered( bool checked = false );

  void on_TV_DirView_clicked(const QModelIndex &idx);
  void on_TV_DirView_doubleClicked ( const QModelIndex & index );

  void slotOpenArchive();
  void slotExtractTo();
  void slotTest();
  void slotView();
  void slotDelete();
  void slotFind();
  void slotWizard();
  void slotInfo();
  void slotChangeUpDirectory();
  void slotTrayActivated(QSystemTrayIcon::ActivationReason reason);

private:
  KalzipApp *m_app;

  QTimer *m_timer1;
  QSystemTrayIcon *m_trayIcon;

  QComboBox *m_CB_CurDir;
  QDirModel *m_DM_Tree;
  QFileInfo *m_FI_Tree;
  
  //QDirModel *m_DM_List;
  //QFileInfo *m_FI_List;

private:
  void initLayout();
  void initTrayIcon();

  void createToolBar();
  void createFileManager();
  
  void ListAlzForGui(CUnAlz* pUnAlz, const char* src);    
signals:
  void sigShowInfo(const QString &);

protected:
  void closeEvent(QCloseEvent *event);
};

#endif
